function nacdiffPER3 = nacdiffPER3(x)

global alpha eta omega rho nu k0 ds de lu ls tauks tauke qe qs qe1 qs1

%non arbitrage condition with differential capital income taxation

ke = x/qe;
ks = (k0 - x)/qs;

brack =(omega*ke^rho + (1-omega)*ls^rho);
parent = ((1-nu)*lu^eta + nu*brack^(eta/rho) );
mpks1 = alpha*ks^(alpha-1)* parent^((1-alpha)/eta);
mpke1 = ks^alpha* ((1-alpha)/eta)*parent^((1-alpha)/eta-1)*nu*eta/rho*brack^(eta/rho-1)*omega*rho*ke^(rho-1);

%now find ke s.t. given ks the NAC holds
%nacdiffPER3 = qs1/qs + (1-tauks)*(mpks - qs*ds)/qs - qe1/qe - (1-tauke)*(mpke - qe*de)/qe;

% depending on whether depreciation allowance on capital used in period t is done using qt or qt+1, no-arbitrage condition will be different 
%nacdiffPER3 = qs1/qs + (1-tauks)*(mpks1 - qs*ds)/qs - qe1/qe - (1-tauke)*(mpke1 - qe*de)/qe; %using qt+1
nacdiffPER3 = qs1/qs*(1-ds) + mpks1*(1-tauks)/qs + tauks*ds -(qe1/qe*(1-de) + mpke1*(1-tauke)/qe + tauke*de); %using qt